﻿init python:
    from copy import copy
    renpy.music.register_channel("flappy_sfx", loop = False)
    class flappy_object:
        def __init__(self, img, width, height):
            self.x = 0
            self.y = 0
            self.speed = 4
            self.img = img
            self.width = width
            self.height = height
    class flappy_class:
        def __init__(self, objects):
            self.bird = "flappy"
            self.x = -300
            self.y = 0
            self.bg = 0
            self.objects = objects
            self.collisions = []
            self.stage = "wait"
            self.speed = 0
            self.points = 0
        def update(self):
            self.bg -= 1
            if self.bg < -1920:
                self.bg = 0
            
            self.speed += 1
            self.y += self.speed
            if self.y > 510 or self.y < -510:
                self.stage = "dead"
                Play("flappy_sfx", "audio/fail.ogg")()
            for i in self.collisions:
                i.x -= i.speed
                if -400 < i.x < -160:
                    self.collision_check(i)
                elif i.x < -1000:
                    self.collisions.remove(i)
                    self.points += 1
                    Play("flappy_sfx", "audio/point.ogg")()
        def collision_check(self, i):
            if i.y - 150 < self.y < i.y + 150:
                self.stage = "dead"
                Play("flappy_sfx", "audio/fail.ogg")()
        def change_stage(self, stage):
            self.stage = stage
        def flap(self):
            self.speed = -20
            Play("sound", "audio/boost.ogg")()
        def reset(self):
            self.points = 0
            self.collisions = []
            self.speed = -10
            self.y = 0
            self.stage = "flapping"
            Play("flappy_sfx", "audio/start.ogg")()
        def spawn(self):
            o = renpy.random.choice(self.objects)
            c = copy(o)
            c.y = renpy.random.randint(-510, 510)
            c.x = 1000
            c.speed = renpy.random.randint(4, 14)
            self.collisions.append(c)

default flappy_1 = flappy_object("flappy_1", 100, 100)
default flappy_2 = flappy_object("flappy_2", 100, 100)
default flappy_3 = flappy_object("flappy_3", 100, 100)
default flappy_4 = flappy_object("flappy_4", 100, 100)
default flappy_5 = flappy_object("flappy_5", 100, 100)
default flappy_6 = flappy_object("flappy_6", 100, 100)
default flappy_7 = flappy_object("flappy_7", 100, 100)
default flappy_8 = flappy_object("flappy_8", 100, 100)
default flappy_9 = flappy_object("flappy_9", 100, 100)
default flappy_10 = flappy_object("flappy_10", 100, 100)
default flappy_11 = flappy_object("flappy_11", 100, 100)
default flappy_12 = flappy_object("flappy_12", 100, 100)



default flappy_game = flappy_class(
    [
        flappy_1, flappy_2, flappy_3, flappy_4, flappy_5,
        flappy_6, flappy_7, flappy_8, flappy_9, flappy_10,
        flappy_11, flappy_12
    ]
)
transform rotate(r):
    rotate_pad False
    rotate r
screen flappy(g = flappy_game):
    add "flappy_bg" xalign .0 xoffset g.bg
    vbox:
        offset 40,40
        text str(g.points) size 40
        # text str(g.bg)
        # text str(g.speed)
        # text str(g.y)
        # text g.stage

    add g.bird align .5,.5 offset g.x, g.y at rotate(g.speed)

    for i in g.collisions:
        add i.img align .5,.5 offset i.x,i.y

    if g.stage == "wait":
        button:
            align .5,.5 background "#313" padding 20,20
            text _("Start")
            action Function(g.reset)
    elif g.stage == "flapping":
        timer .016 repeat True action Function(g.update)
        timer renpy.random.randint(1, 5) repeat True action Function(g.spawn)
        button:
            action Function(g.flap) keysym "K_SPACE"
    elif g.stage == "dead":
        hbox:
            align .5,.5 spacing 10
            button:
                background "#313" padding 20,20
                text _("Reset")
                action Function(g.reset)
            button:
                background "#313" padding 20,20
                text _("Done")
                action Return(g.points)


label flappy_example:
    $ quick_menu = False
    call screen flappy
    "You've got [_return] points."

    """
    Credits for the monsters art:\n
    JosephSeraph\n
    https://opengameart.org/content/js-monster-set-elementals-iii\n
    https://opengameart.org/content/js-monster-set-elementals\n
    https://opengameart.org/content/js-monster-set-elementals-ii\n

    """
    """
    Credits for the battleship's art:\n
    TheSource4Life\n
    https://opengameart.org/content/space-ships-side-scroller\n

    """
